gtkmm: Gtk::Builder Class Reference

gtkmm 2.24.4

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::Builder Class Reference

Build an interface from a UI definition description. More...

Inheritance diagram for Gtk::Builder:
[legend]
Collaboration diagram for Gtk::Builder:
[legend]

## Public Member Functions
| Builder (Builder&& src) noexcept
Builder& | operator= (Builder&& src) noexcept
| ~Builder () noexceptoverride
GtkBuilder* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkBuilder* | gobj () const
| Provides access to the underlying C GObject. More...
GtkBuilder* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | add_from_file (const std::string& filename)
| Parses a file containing a GtkBuilder UI definition, and merges it with the current contents of the builder. More...
bool | add_from_file (const std::string& filename, const char* object_id)
| Parses a file containing a GtkBuilder UI definition, building only the requested object, and merges it with the current contents of the builder. More...
bool | add_from_file (const std::string& filename, const Glib::ustring& object_id)
| Parses a file containing a GtkBuilder UI definition, building only the requested object, and merges it with the current contents of the builder. More...
bool | add_from_file (const std::string& filename, const Glib::StringArrayHandle& object_ids)
| Parses a file containing a GtkBuilder UI definition building only the requested objects and merges them with the current contents of builder. More...
bool | add_from_string (const Glib::ustring& buffer)
| Parses a string containing a GtkBuilder UI definition and merges it with the current contents of the builder. More...
bool | add_from_string (const Glib::ustring& buffer, const char* object_id)
| Parses a string containing a GtkBuilder UI definition, building only the requested object, and merges it with the current contents of the builder. More...
bool | add_from_string (const Glib::ustring& buffer, const Glib::ustring& object_id)
| Parses a string containing a GtkBuilder UI definition, building only the requested object, and merges it with the current contents of the builder. More...
bool | add_from_string (const Glib::ustring& buffer, const Glib::StringArrayHandle& object_ids)
| Parses a string containing a GtkBuilder UI definition, building only the requested objects, and merges it with the current contents of the builder. More...
bool | add_from_string (const char* buffer, gsize length)
| Parses a string containing a GtkBuilder UI definition and merges it with the current contents of the builder. More...
Glib::RefPtr< Glib::Object > | get_object (const Glib::ustring& name)
| Gets the object named name. More...
template<class T_Widget >
void | get_widget (const Glib::ustring& name, T_Widget*& widget)
| Get a widget from the Builder file. More...
template<class T_Widget >
void | get_widget_derived (const Glib::ustring& name, T_Widget*& widget)
| This provides a pointer to a widget whose details are specified in the GtkBuilder file, but which is implemented by your own derived class. More...
void | set_translation_domain (const Glib::ustring& domain)
| Sets the translation domain of builder. More...
Glib::ustring | get_translation_domain () const
| Gets the translation domain of builder. More...
Glib::PropertyProxy< Glib::ustring > | property_translation_domain ()
| The translation domain used by gettext. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_translation_domain () const
| The translation domain used by gettext. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< Builder > | create ()
| Creates a new builder object. More...
static Glib::RefPtr< Builder > | create_from_file (const std::string& filename)
| Parses a file containing a GtkBuilder UI definition. More...
static Glib::RefPtr< Builder > | create_from_file (const std::string& filename, const Glib::ustring& object_id)
| Parses a file containing a GtkBuilder UI definition, building only the requested object. More...
static Glib::RefPtr< Builder > | create_from_file (const std::string& filename, const char* object_id)
| Parses a file containing a GtkBuilder UI definition, building only the requested object. More...
static Glib::RefPtr< Builder > | create_from_file (const std::string& filename, const Glib::StringArrayHandle& object_ids)
| Parses a file containing a GtkBuilder UI definition, building only the requested objects. More...
static Glib::RefPtr< Builder > | create_from_string (const Glib::ustring& buffer)
| Parses a string containing a GtkBuilder UI definition. More...
static Glib::RefPtr< Builder > | create_from_string (const Glib::ustring& buffer, const char* object_id)
| Parses a string containing a GtkBuilder UI definition building only the requested object. More...
static Glib::RefPtr< Builder > | create_from_string (const Glib::ustring& buffer, const Glib::ustring& object_id)
| Parses a string containing a GtkBuilder UI definition building only the requested object. More...
static Glib::RefPtr< Builder > | create_from_string (const Glib::ustring& buffer, const Glib::StringArrayHandle& object_ids)
| Parses a string containing a GtkBuilder UI definition building only the requested objects. More...

## Protected Member Functions
| Builder ()
Gtk::Widget* | get_widget_checked (const Glib::ustring& name, GType type)
GtkWidget* | get_cwidget (const Glib::ustring& name)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexceptoverride
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::Builder > | wrap (GtkBuilder* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Build an interface from a UI definition description.

This object represents an `instantiation' of an UI definition description. When one of these objects is created, the XML file is read, and the interface is created. The Gtk::Builder object then provides an interface for accessing the widgets in the interface by the names assigned to them inside the UI description.

Since gtkmm 2.12:

## Constructor & Destructor Documentation

Gtk::Builder::Builder | ( | Builder&& | src | ) |
| noexcept

Gtk::Builder::~Builder | ( |  | ) |
| overridenoexcept

Gtk::Builder::Builder | ( |  | ) |
| protected

## Member Function Documentation

bool Gtk::Builder::add_from_file | ( | const std::string & | filename | ) |

Parses a file containing a GtkBuilder UI definition, and merges it with the current contents of the builder.

Parameters

  buffer | The file to parse.

Returns
  true on success or false if an error occurred.

Exceptions

  BuilderError,Glib::MarkupError,Glib::MarkupError |

Since gtkmm 2.14:

bool Gtk::Builder::add_from_file | ( | const std::string & | filename,
|  | const char * | object_id
| ) |  |

Parses a file containing a GtkBuilder UI definition, building only the requested object, and merges it with the current contents of the builder.

If you are adding an object that depends on an object that is not its child (for instance a GtkTreeView that depends on its GtkTreeModel), you have to explicitely list all of them.

Parameters

  buffer | The file to parse.
  The | object to build.

Returns
  true on success or false if an error occurred.

Exceptions

  BuilderError,Glib::MarkupError,Glib::MarkupError |

Since gtkmm 2.16:

bool Gtk::Builder::add_from_file | ( | const std::string & | filename,
|  | const Glib::ustring & | object_id
| ) |  |

Parses a file containing a GtkBuilder UI definition, building only the requested object, and merges it with the current contents of the builder.

If you are adding an object that depends on an object that is not its child (for instance a GtkTreeView that depends on its GtkTreeModel), you have to explicitely list all of them.

Parameters

  buffer | The file to parse.
  The | object to build.

Returns
  true on success or false if an error occurred.

Exceptions

  BuilderError,Glib::MarkupError,Glib::MarkupError |

Since gtkmm 2.14:

bool Gtk::Builder::add_from_file | ( | const std::string & | filename,
|  | const Glib::StringArrayHandle & | object_ids
| ) |  |

Parses a file containing a GtkBuilder UI definition building only the requested objects and merges them with the current contents of builder.

Upon errors 0 will be returned and error will be assigned a Error from the Gtk::BUILDER_ERROR, MARKUP_ERROR or FILE_ERROR domain.

<note> If you are adding an object that depends on an object that is not its child (for instance a Gtk::TreeView that depends on its Gtk::TreeModel), you have to explicitely list all of them in object_ids. </note>

Since gtkmm 2.14:

Parameters

  filename | The name of the file to parse.
  object_ids | Nul-terminated array of objects to build.

Returns
  A positive value on success, 0 if an error occurred.

bool Gtk::Builder::add_from_string | ( | const Glib::ustring & | buffer | ) |

Parses a string containing a GtkBuilder UI definition and merges it with the current contents of the builder.

Parameters

  buffer | The string to parse.

Returns
  true on success or false if an error occurred.

Exceptions

  BuilderError,Glib::MarkupError |

Since gtkmm 2.12:

bool Gtk::Builder::add_from_string | ( | const Glib::ustring & | buffer,
|  | const char * | object_id
| ) |  |

Parses a string containing a GtkBuilder UI definition, building only the requested object, and merges it with the current contents of the builder.

Parameters

  buffer | The string to parse.
  The | object to build.

Returns
  true on success or false if an error occurred.

Exceptions

  BuilderError,Glib::MarkupError |

Since gtkmm 2.16:

bool Gtk::Builder::add_from_string | ( | const Glib::ustring & | buffer,
|  | const Glib::ustring & | object_id
| ) |  |

Parses a string containing a GtkBuilder UI definition, building only the requested object, and merges it with the current contents of the builder.

Parameters

  buffer | The string to parse.
  The | object to build.

Returns
  true on success or false if an error occurred.

Exceptions

  BuilderError,Glib::MarkupError |

Since gtkmm 2.14:

bool Gtk::Builder::add_from_string | ( | const Glib::ustring & | buffer,
|  | const Glib::StringArrayHandle & | object_ids
| ) |  |

Parses a string containing a GtkBuilder UI definition, building only the requested objects, and merges it with the current contents of the builder.

Parameters

  buffer | The string to parse.
  The | objects to build.

Returns
  true on success or false if an error occurred.

Exceptions

  BuilderError,Glib::MarkupError |

Since gtkmm 2.14:

bool Gtk::Builder::add_from_string | ( | const char * | buffer,
|  | gsize | length
| ) |  |

Parses a string containing a GtkBuilder UI definition and merges it with the current contents of the builder.

Parameters

  buffer | The string to parse.
  length | The length of buffer (may be -1 if is nul-terminated).

Returns
  true on success or false if an error occurred.

Exceptions

  BuilderError,Glib::MarkupError |

Since gtkmm 2.12:

static Glib::RefPtr<Builder> Gtk::Builder::create | ( |  | ) |
| static

Creates a new builder object.

static Glib::RefPtr<Builder> Gtk::Builder::create_from_file | ( | const std::string & | filename | ) |
| static

Parses a file containing a GtkBuilder UI definition.

Parameters

  filename | the name of the file to parse.

Returns
  A new Builder object, or a null pointer if an error occurred.

Exceptions

  BuilderError,Glib::MarkupError,Glib::FileError |

Since gtkmm 2.12:

static Glib::RefPtr<Builder> Gtk::Builder::create_from_file | ( | const std::string & | filename,
|  | const Glib::ustring & | object_id
| ) |  |
| static

Parses a file containing a GtkBuilder UI definition, building only the requested object.

If you are adding an object that depends on an object that is not its child (for instance a GtkTreeView that depends on its GtkTreeModel), you have to explicitely list all of them.

Parameters

  filename | the name of the file to parse.
  object_id | The object to build.

Returns
  A new Builder object, or a null pointer if an error occurred.

Exceptions

  BuilderError,Glib::MarkupError,Glib::FileError |

Since gtkmm 2.14:

static Glib::RefPtr<Builder> Gtk::Builder::create_from_file | ( | const std::string & | filename,
|  | const char * | object_id
| ) |  |
| static

Parses a file containing a GtkBuilder UI definition, building only the requested object.

If you are adding an object that depends on an object that is not its child (for instance a GtkTreeView that depends on its GtkTreeModel), you have to explicitely list all of them.

Parameters

  filename | the name of the file to parse.
  object_id | The object to build.

Returns
  A new Builder object, or a null pointer if an error occurred.

Exceptions

  BuilderError,Glib::MarkupError,Glib::FileError |

Since gtkmm 2.16:

static Glib::RefPtr<Builder> Gtk::Builder::create_from_file | ( | const std::string & | filename,
|  | const Glib::StringArrayHandle & | object_ids
| ) |  |
| static

Parses a file containing a GtkBuilder UI definition, building only the requested objects.

If you are adding an object that depends on an object that is not its child (for instance a GtkTreeView that depends on its GtkTreeModel), you have to explicitely list all of them.

Parameters

  filename | the name of the file to parse.
  object_ids | The objects to build.

Returns
  A new Builder object, or a null pointer if an error occurred.

Exceptions

  BuilderError,Glib::MarkupError,Glib::FileError |

Since gtkmm 2.14:

static Glib::RefPtr<Builder> Gtk::Builder::create_from_string | ( | const Glib::ustring & | buffer | ) |
| static

Parses a string containing a GtkBuilder UI definition.

Parameters

  buffer | the string to parse

Returns
  A new Builder object, or a null pointer if an error occurred.

Exceptions

  BuilderError,Glib::MarkupError |

Since gtkmm 2.12:

static Glib::RefPtr<Builder> Gtk::Builder::create_from_string | ( | const Glib::ustring & | buffer,
|  | const char * | object_id
| ) |  |
| static

Parses a string containing a GtkBuilder UI definition building only the requested object.

Parameters

  buffer | The string to parse.
  object_id | The object to build.

Returns
  A new Builder object, or a null pointer if an error occurred.

Exceptions

  BuilderError,Glib::MarkupError |

Since gtkmm 2.16:

static Glib::RefPtr<Builder> Gtk::Builder::create_from_string | ( | const Glib::ustring & | buffer,
|  | const Glib::ustring & | object_id
| ) |  |
| static

Parses a string containing a GtkBuilder UI definition building only the requested object.

Parameters

  buffer | The string to parse.
  object_id | The object to build.

Returns
  A new Builder object, or a null pointer if an error occurred.

Exceptions

  BuilderError,Glib::MarkupError |

Since gtkmm 2.14:

static Glib::RefPtr<Builder> Gtk::Builder::create_from_string | ( | const Glib::ustring & | buffer,
|  | const Glib::StringArrayHandle & | object_ids
| ) |  |
| static

Parses a string containing a GtkBuilder UI definition building only the requested objects.

If you are adding an object that depends on an object that is not its child (for instance a GtkTreeView that depends on its GtkTreeModel), you have to explicitely list all of them.

Parameters

  buffer | the string to parse
  object_ids | The objects to build.

Returns
  A new Builder object, or a null pointer if an error occurred.

Exceptions

  BuilderError,Glib::MarkupError |

Since gtkmm 2.14:

GtkWidget* Gtk::Builder::get_cwidget | ( | const Glib::ustring & | name | ) |
| protected

Glib::RefPtr<Glib::Object> Gtk::Builder::get_object | ( | const Glib::ustring & | name | ) |

Gets the object named name.

Note that this function does not increment the reference count of the returned object.

Since gtkmm 2.12:

Parameters

  name | Name of object to get.

Returns
  The object named name or `nullptr` if it could not be found in the object tree.

Glib::ustring Gtk::Builder::get_translation_domain | ( |  | ) | const

Gets the translation domain of builder.

Since gtkmm 2.12:

Returns
  The translation domain. This string is owned by the builder object and must not be modified or freed.

static GType Gtk::Builder::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

template <class T_Widget >

void Gtk::Builder::get_widget | ( | const Glib::ustring & | name,
|  | T_Widget *& | widget
| ) |  |
| inline

Get a widget from the Builder file.

For instance:

Gtk::Table* pTable = 0;
refXml->get_widget("mytable", pTable);

This method prints a warning message to the console if the widget doesn't exist or has the wrong type, so you don't need to check that manually.

Note that you are responsible for deleting top-level widgets (windows and dialogs) instantiated by the Builder object. Other widgets are instantiated as managed so they will be deleted automatically if you add them to a container widget.

Parameters

  name | The name of the widget.

Return values

  widget | A pointer to the widget, or `0` on failure.

Gtk::Widget* Gtk::Builder::get_widget_checked | ( | const Glib::ustring & | name,
|  | GType | type
| ) |  |
| protected

template <class T_Widget >

void Gtk::Builder::get_widget_derived | ( | const Glib::ustring & | name,
|  | T_Widget *& | widget
| ) |  |
| inline

This provides a pointer to a widget whose details are specified in the GtkBuilder file, but which is implemented by your own derived class.

Your class must have a constructor like so:

DerivedDialog::DerivedDialog(BaseObjectType* cobject, const Glib::RefPtr<Gtk::Builder>& refBuilder)
: Gtk::Dialog(cobject) //Calls the base class constructor

For instance:

Gtk::DerivedBox* pBox = 0;
refXml->get_widget_derived("mybox", pBox);

Parameters

  name | The name of the widget.

Return values

  widget | A pointer to the widget, or `0` on failure.

GtkBuilder* Gtk::Builder::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GtkBuilder* Gtk::Builder::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GtkBuilder* Gtk::Builder::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Builder& Gtk::Builder::operator= | ( | Builder&& | src | ) |
| noexcept

Glib::PropertyProxy< Glib::ustring > Gtk::Builder::property_translation_domain | ( |  | ) |

The translation domain used by gettext.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Builder::property_translation_domain | ( |  | ) | const

The translation domain used by gettext.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

void Gtk::Builder::set_translation_domain | ( | const Glib::ustring & | domain | ) |

Sets the translation domain of builder.

See Gtk::Builder::property_translation_domain().

Since gtkmm 2.12:

Parameters

  domain | The translation domain or `nullptr`.

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::Builder > wrap | ( | GtkBuilder * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/builder.h